package dnsknocker

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetResourceRecords invokes the dnsknocker.GetResourceRecords API synchronously
// api document: https://help.aliyun.com/api/dnsknocker/getresourcerecords.html
func (client *Client) GetResourceRecords(request *GetResourceRecordsRequest) (response *GetResourceRecordsResponse, err error) {
	response = CreateGetResourceRecordsResponse()
	err = client.DoAction(request, response)
	return
}

// GetResourceRecordsWithChan invokes the dnsknocker.GetResourceRecords API asynchronously
// api document: https://help.aliyun.com/api/dnsknocker/getresourcerecords.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetResourceRecordsWithChan(request *GetResourceRecordsRequest) (<-chan *GetResourceRecordsResponse, <-chan error) {
	responseChan := make(chan *GetResourceRecordsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetResourceRecords(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetResourceRecordsWithCallback invokes the dnsknocker.GetResourceRecords API asynchronously
// api document: https://help.aliyun.com/api/dnsknocker/getresourcerecords.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetResourceRecordsWithCallback(request *GetResourceRecordsRequest, callback func(response *GetResourceRecordsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetResourceRecordsResponse
		var err error
		defer close(result)
		response, err = client.GetResourceRecords(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetResourceRecordsRequest is the request struct for api GetResourceRecords
type GetResourceRecordsRequest struct {
	*requests.RpcRequest
	AccessID      string `position:"Body" name:"AccessID"`
	AccessSecret  string `position:"Body" name:"AccessSecret"`
	Zone          string `position:"Body" name:"Zone"`
	DomainName    string `position:"Body" name:"DomainName"`
	TransactionId string `position:"Body" name:"TransactionId"`
	DomainLine    string `position:"Body" name:"DomainLine"`
	Group         string `position:"Body" name:"Group"`
}

// GetResourceRecordsResponse is the response struct for api GetResourceRecords
type GetResourceRecordsResponse struct {
	*responses.BaseResponse
	ResultCode        string   `json:"ResultCode" xml:"ResultCode"`
	ResultMessage     string   `json:"ResultMessage" xml:"ResultMessage"`
	Success           bool     `json:"Success" xml:"Success"`
	RequestId         string   `json:"RequestId" xml:"RequestId"`
	ResourceRecordSet []string `json:"ResourceRecordSet" xml:"ResourceRecordSet"`
}

// CreateGetResourceRecordsRequest creates a request to invoke GetResourceRecords API
func CreateGetResourceRecordsRequest() (request *GetResourceRecordsRequest) {
	request = &GetResourceRecordsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("DnsKnocker", "2019-09-10", "GetResourceRecords", "dns_knocker", "openAPI")
	return
}

// CreateGetResourceRecordsResponse creates a response to parse from GetResourceRecords response
func CreateGetResourceRecordsResponse() (response *GetResourceRecordsResponse) {
	response = &GetResourceRecordsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
