package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ChangeInstanceNetwork invokes the drds.ChangeInstanceNetwork API synchronously
// api document: https://help.aliyun.com/api/drds/changeinstancenetwork.html
func (client *Client) ChangeInstanceNetwork(request *ChangeInstanceNetworkRequest) (response *ChangeInstanceNetworkResponse, err error) {
	response = CreateChangeInstanceNetworkResponse()
	err = client.DoAction(request, response)
	return
}

// ChangeInstanceNetworkWithChan invokes the drds.ChangeInstanceNetwork API asynchronously
// api document: https://help.aliyun.com/api/drds/changeinstancenetwork.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ChangeInstanceNetworkWithChan(request *ChangeInstanceNetworkRequest) (<-chan *ChangeInstanceNetworkResponse, <-chan error) {
	responseChan := make(chan *ChangeInstanceNetworkResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ChangeInstanceNetwork(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ChangeInstanceNetworkWithCallback invokes the drds.ChangeInstanceNetwork API asynchronously
// api document: https://help.aliyun.com/api/drds/changeinstancenetwork.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ChangeInstanceNetworkWithCallback(request *ChangeInstanceNetworkRequest, callback func(response *ChangeInstanceNetworkResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ChangeInstanceNetworkResponse
		var err error
		defer close(result)
		response, err = client.ChangeInstanceNetwork(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ChangeInstanceNetworkRequest is the request struct for api ChangeInstanceNetwork
type ChangeInstanceNetworkRequest struct {
	*requests.RpcRequest
	VswitchId              string           `position:"Query" name:"VswitchId"`
	RetainClassic          requests.Boolean `position:"Query" name:"RetainClassic"`
	ClassicExpiredDays     requests.Integer `position:"Query" name:"ClassicExpiredDays"`
	VpcId                  string           `position:"Query" name:"VpcId"`
	SrcInstanceNetworkType string           `position:"Query" name:"SrcInstanceNetworkType"`
	DrdsInstanceId         string           `position:"Query" name:"DrdsInstanceId"`
}

// ChangeInstanceNetworkResponse is the response struct for api ChangeInstanceNetwork
type ChangeInstanceNetworkResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateChangeInstanceNetworkRequest creates a request to invoke ChangeInstanceNetwork API
func CreateChangeInstanceNetworkRequest() (request *ChangeInstanceNetworkRequest) {
	request = &ChangeInstanceNetworkRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "ChangeInstanceNetwork", "drds", "openAPI")
	return
}

// CreateChangeInstanceNetworkResponse creates a response to parse from ChangeInstanceNetwork response
func CreateChangeInstanceNetworkResponse() (response *ChangeInstanceNetworkResponse) {
	response = &ChangeInstanceNetworkResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
