package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CheckCapacityDataReady invokes the drds.CheckCapacityDataReady API synchronously
// api document: https://help.aliyun.com/api/drds/checkcapacitydataready.html
func (client *Client) CheckCapacityDataReady(request *CheckCapacityDataReadyRequest) (response *CheckCapacityDataReadyResponse, err error) {
	response = CreateCheckCapacityDataReadyResponse()
	err = client.DoAction(request, response)
	return
}

// CheckCapacityDataReadyWithChan invokes the drds.CheckCapacityDataReady API asynchronously
// api document: https://help.aliyun.com/api/drds/checkcapacitydataready.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CheckCapacityDataReadyWithChan(request *CheckCapacityDataReadyRequest) (<-chan *CheckCapacityDataReadyResponse, <-chan error) {
	responseChan := make(chan *CheckCapacityDataReadyResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CheckCapacityDataReady(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CheckCapacityDataReadyWithCallback invokes the drds.CheckCapacityDataReady API asynchronously
// api document: https://help.aliyun.com/api/drds/checkcapacitydataready.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CheckCapacityDataReadyWithCallback(request *CheckCapacityDataReadyRequest, callback func(response *CheckCapacityDataReadyResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CheckCapacityDataReadyResponse
		var err error
		defer close(result)
		response, err = client.CheckCapacityDataReady(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CheckCapacityDataReadyRequest is the request struct for api CheckCapacityDataReady
type CheckCapacityDataReadyRequest struct {
	*requests.RpcRequest
	DbName         string `position:"Query" name:"DbName"`
	DrdsInstanceId string `position:"Query" name:"DrdsInstanceId"`
}

// CheckCapacityDataReadyResponse is the response struct for api CheckCapacityDataReady
type CheckCapacityDataReadyResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      bool   `json:"Data" xml:"Data"`
}

// CreateCheckCapacityDataReadyRequest creates a request to invoke CheckCapacityDataReady API
func CreateCheckCapacityDataReadyRequest() (request *CheckCapacityDataReadyRequest) {
	request = &CheckCapacityDataReadyRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "CheckCapacityDataReady", "drds", "openAPI")
	return
}

// CreateCheckCapacityDataReadyResponse creates a response to parse from CheckCapacityDataReady response
func CreateCheckCapacityDataReadyResponse() (response *CheckCapacityDataReadyResponse) {
	response = &CheckCapacityDataReadyResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
