package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeCandidateInstanceList invokes the drds.DescribeCandidateInstanceList API synchronously
// api document: https://help.aliyun.com/api/drds/describecandidateinstancelist.html
func (client *Client) DescribeCandidateInstanceList(request *DescribeCandidateInstanceListRequest) (response *DescribeCandidateInstanceListResponse, err error) {
	response = CreateDescribeCandidateInstanceListResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeCandidateInstanceListWithChan invokes the drds.DescribeCandidateInstanceList API asynchronously
// api document: https://help.aliyun.com/api/drds/describecandidateinstancelist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeCandidateInstanceListWithChan(request *DescribeCandidateInstanceListRequest) (<-chan *DescribeCandidateInstanceListResponse, <-chan error) {
	responseChan := make(chan *DescribeCandidateInstanceListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeCandidateInstanceList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeCandidateInstanceListWithCallback invokes the drds.DescribeCandidateInstanceList API asynchronously
// api document: https://help.aliyun.com/api/drds/describecandidateinstancelist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeCandidateInstanceListWithCallback(request *DescribeCandidateInstanceListRequest, callback func(response *DescribeCandidateInstanceListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeCandidateInstanceListResponse
		var err error
		defer close(result)
		response, err = client.DescribeCandidateInstanceList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeCandidateInstanceListRequest is the request struct for api DescribeCandidateInstanceList
type DescribeCandidateInstanceListRequest struct {
	*requests.RpcRequest
	Search         string           `position:"Query" name:"Search"`
	DbName         string           `position:"Query" name:"DbName"`
	AcrossZone     requests.Boolean `position:"Query" name:"AcrossZone"`
	PageSize       requests.Integer `position:"Query" name:"PageSize"`
	DrdsInstanceId string           `position:"Query" name:"DrdsInstanceId"`
	PageNumber     requests.Integer `position:"Query" name:"PageNumber"`
}

// DescribeCandidateInstanceListResponse is the response struct for api DescribeCandidateInstanceList
type DescribeCandidateInstanceListResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateDescribeCandidateInstanceListRequest creates a request to invoke DescribeCandidateInstanceList API
func CreateDescribeCandidateInstanceListRequest() (request *DescribeCandidateInstanceListRequest) {
	request = &DescribeCandidateInstanceListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeCandidateInstanceList", "drds", "openAPI")
	return
}

// CreateDescribeCandidateInstanceListResponse creates a response to parse from DescribeCandidateInstanceList response
func CreateDescribeCandidateInstanceListResponse() (response *DescribeCandidateInstanceListResponse) {
	response = &DescribeCandidateInstanceListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
