package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeConsoleConfig invokes the drds.DescribeConsoleConfig API synchronously
// api document: https://help.aliyun.com/api/drds/describeconsoleconfig.html
func (client *Client) DescribeConsoleConfig(request *DescribeConsoleConfigRequest) (response *DescribeConsoleConfigResponse, err error) {
	response = CreateDescribeConsoleConfigResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeConsoleConfigWithChan invokes the drds.DescribeConsoleConfig API asynchronously
// api document: https://help.aliyun.com/api/drds/describeconsoleconfig.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeConsoleConfigWithChan(request *DescribeConsoleConfigRequest) (<-chan *DescribeConsoleConfigResponse, <-chan error) {
	responseChan := make(chan *DescribeConsoleConfigResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeConsoleConfig(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeConsoleConfigWithCallback invokes the drds.DescribeConsoleConfig API asynchronously
// api document: https://help.aliyun.com/api/drds/describeconsoleconfig.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeConsoleConfigWithCallback(request *DescribeConsoleConfigRequest, callback func(response *DescribeConsoleConfigResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeConsoleConfigResponse
		var err error
		defer close(result)
		response, err = client.DescribeConsoleConfig(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeConsoleConfigRequest is the request struct for api DescribeConsoleConfig
type DescribeConsoleConfigRequest struct {
	*requests.RpcRequest
	Type string `position:"Query" name:"Type"`
}

// DescribeConsoleConfigResponse is the response struct for api DescribeConsoleConfig
type DescribeConsoleConfigResponse struct {
	*responses.BaseResponse
	RequestId string                 `json:"RequestId" xml:"RequestId"`
	Success   bool                   `json:"Success" xml:"Success"`
	Config    map[string]interface{} `json:"Config" xml:"Config"`
}

// CreateDescribeConsoleConfigRequest creates a request to invoke DescribeConsoleConfig API
func CreateDescribeConsoleConfigRequest() (request *DescribeConsoleConfigRequest) {
	request = &DescribeConsoleConfigRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeConsoleConfig", "drds", "openAPI")
	return
}

// CreateDescribeConsoleConfigResponse creates a response to parse from DescribeConsoleConfig response
func CreateDescribeConsoleConfigResponse() (response *DescribeConsoleConfigResponse) {
	response = &DescribeConsoleConfigResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
