package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDrdsDbRdsRelationInfo invokes the drds.DescribeDrdsDbRdsRelationInfo API synchronously
// api document: https://help.aliyun.com/api/drds/describedrdsdbrdsrelationinfo.html
func (client *Client) DescribeDrdsDbRdsRelationInfo(request *DescribeDrdsDbRdsRelationInfoRequest) (response *DescribeDrdsDbRdsRelationInfoResponse, err error) {
	response = CreateDescribeDrdsDbRdsRelationInfoResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDrdsDbRdsRelationInfoWithChan invokes the drds.DescribeDrdsDbRdsRelationInfo API asynchronously
// api document: https://help.aliyun.com/api/drds/describedrdsdbrdsrelationinfo.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDrdsDbRdsRelationInfoWithChan(request *DescribeDrdsDbRdsRelationInfoRequest) (<-chan *DescribeDrdsDbRdsRelationInfoResponse, <-chan error) {
	responseChan := make(chan *DescribeDrdsDbRdsRelationInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDrdsDbRdsRelationInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDrdsDbRdsRelationInfoWithCallback invokes the drds.DescribeDrdsDbRdsRelationInfo API asynchronously
// api document: https://help.aliyun.com/api/drds/describedrdsdbrdsrelationinfo.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDrdsDbRdsRelationInfoWithCallback(request *DescribeDrdsDbRdsRelationInfoRequest, callback func(response *DescribeDrdsDbRdsRelationInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDrdsDbRdsRelationInfoResponse
		var err error
		defer close(result)
		response, err = client.DescribeDrdsDbRdsRelationInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDrdsDbRdsRelationInfoRequest is the request struct for api DescribeDrdsDbRdsRelationInfo
type DescribeDrdsDbRdsRelationInfoRequest struct {
	*requests.RpcRequest
	DbName         string `position:"Query" name:"DbName"`
	DrdsInstanceId string `position:"Query" name:"DrdsInstanceId"`
}

// DescribeDrdsDbRdsRelationInfoResponse is the response struct for api DescribeDrdsDbRdsRelationInfo
type DescribeDrdsDbRdsRelationInfoResponse struct {
	*responses.BaseResponse
	RequestId string                              `json:"RequestId" xml:"RequestId"`
	Success   bool                                `json:"Success" xml:"Success"`
	Data      DataInDescribeDrdsDbRdsRelationInfo `json:"Data" xml:"Data"`
}

// CreateDescribeDrdsDbRdsRelationInfoRequest creates a request to invoke DescribeDrdsDbRdsRelationInfo API
func CreateDescribeDrdsDbRdsRelationInfoRequest() (request *DescribeDrdsDbRdsRelationInfoRequest) {
	request = &DescribeDrdsDbRdsRelationInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeDrdsDbRdsRelationInfo", "drds", "openAPI")
	return
}

// CreateDescribeDrdsDbRdsRelationInfoResponse creates a response to parse from DescribeDrdsDbRdsRelationInfo response
func CreateDescribeDrdsDbRdsRelationInfoResponse() (response *DescribeDrdsDbRdsRelationInfoResponse) {
	response = &DescribeDrdsDbRdsRelationInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
