package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRdsPrice invokes the drds.DescribeRdsPrice API synchronously
// api document: https://help.aliyun.com/api/drds/describerdsprice.html
func (client *Client) DescribeRdsPrice(request *DescribeRdsPriceRequest) (response *DescribeRdsPriceResponse, err error) {
	response = CreateDescribeRdsPriceResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRdsPriceWithChan invokes the drds.DescribeRdsPrice API asynchronously
// api document: https://help.aliyun.com/api/drds/describerdsprice.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRdsPriceWithChan(request *DescribeRdsPriceRequest) (<-chan *DescribeRdsPriceResponse, <-chan error) {
	responseChan := make(chan *DescribeRdsPriceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRdsPrice(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRdsPriceWithCallback invokes the drds.DescribeRdsPrice API asynchronously
// api document: https://help.aliyun.com/api/drds/describerdsprice.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRdsPriceWithCallback(request *DescribeRdsPriceRequest, callback func(response *DescribeRdsPriceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRdsPriceResponse
		var err error
		defer close(result)
		response, err = client.DescribeRdsPrice(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRdsPriceRequest is the request struct for api DescribeRdsPrice
type DescribeRdsPriceRequest struct {
	*requests.RpcRequest
	Params string `position:"Query" name:"Params"`
}

// DescribeRdsPriceResponse is the response struct for api DescribeRdsPrice
type DescribeRdsPriceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateDescribeRdsPriceRequest creates a request to invoke DescribeRdsPrice API
func CreateDescribeRdsPriceRequest() (request *DescribeRdsPriceRequest) {
	request = &DescribeRdsPriceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeRdsPrice", "drds", "openAPI")
	return
}

// CreateDescribeRdsPriceResponse creates a response to parse from DescribeRdsPrice response
func CreateDescribeRdsPriceResponse() (response *DescribeRdsPriceResponse) {
	response = &DescribeRdsPriceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
