package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeSrcRdsList invokes the drds.DescribeSrcRdsList API synchronously
// api document: https://help.aliyun.com/api/drds/describesrcrdslist.html
func (client *Client) DescribeSrcRdsList(request *DescribeSrcRdsListRequest) (response *DescribeSrcRdsListResponse, err error) {
	response = CreateDescribeSrcRdsListResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeSrcRdsListWithChan invokes the drds.DescribeSrcRdsList API asynchronously
// api document: https://help.aliyun.com/api/drds/describesrcrdslist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeSrcRdsListWithChan(request *DescribeSrcRdsListRequest) (<-chan *DescribeSrcRdsListResponse, <-chan error) {
	responseChan := make(chan *DescribeSrcRdsListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeSrcRdsList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeSrcRdsListWithCallback invokes the drds.DescribeSrcRdsList API asynchronously
// api document: https://help.aliyun.com/api/drds/describesrcrdslist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeSrcRdsListWithCallback(request *DescribeSrcRdsListRequest, callback func(response *DescribeSrcRdsListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeSrcRdsListResponse
		var err error
		defer close(result)
		response, err = client.DescribeSrcRdsList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeSrcRdsListRequest is the request struct for api DescribeSrcRdsList
type DescribeSrcRdsListRequest struct {
	*requests.RpcRequest
	DbName           string                                `position:"Query" name:"DbName"`
	PartitionMapping *[]DescribeSrcRdsListPartitionMapping `position:"Query" name:"PartitionMapping"  type:"Repeated"`
	DrdsInstanceId   string                                `position:"Query" name:"DrdsInstanceId"`
}

// DescribeSrcRdsListPartitionMapping is a repeated param struct in DescribeSrcRdsListRequest
type DescribeSrcRdsListPartitionMapping struct {
	DbShardValue string `name:"DbShardValue"`
	HotDbName    string `name:"HotDbName"`
	HotTableName string `name:"HotTableName"`
	TbShardValue string `name:"TbShardValue"`
	LogicTable   string `name:"LogicTable"`
}

// DescribeSrcRdsListResponse is the response struct for api DescribeSrcRdsList
type DescribeSrcRdsListResponse struct {
	*responses.BaseResponse
	RequestId string                   `json:"RequestId" xml:"RequestId"`
	Success   bool                     `json:"Success" xml:"Success"`
	Data      DataInDescribeSrcRdsList `json:"Data" xml:"Data"`
}

// CreateDescribeSrcRdsListRequest creates a request to invoke DescribeSrcRdsList API
func CreateDescribeSrcRdsListRequest() (request *DescribeSrcRdsListRequest) {
	request = &DescribeSrcRdsListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeSrcRdsList", "drds", "openAPI")
	return
}

// CreateDescribeSrcRdsListResponse creates a response to parse from DescribeSrcRdsList response
func CreateDescribeSrcRdsListResponse() (response *DescribeSrcRdsListResponse) {
	response = &DescribeSrcRdsListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
