package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeStorageInstanceSubDbInfo invokes the drds.DescribeStorageInstanceSubDbInfo API synchronously
// api document: https://help.aliyun.com/api/drds/describestorageinstancesubdbinfo.html
func (client *Client) DescribeStorageInstanceSubDbInfo(request *DescribeStorageInstanceSubDbInfoRequest) (response *DescribeStorageInstanceSubDbInfoResponse, err error) {
	response = CreateDescribeStorageInstanceSubDbInfoResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeStorageInstanceSubDbInfoWithChan invokes the drds.DescribeStorageInstanceSubDbInfo API asynchronously
// api document: https://help.aliyun.com/api/drds/describestorageinstancesubdbinfo.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeStorageInstanceSubDbInfoWithChan(request *DescribeStorageInstanceSubDbInfoRequest) (<-chan *DescribeStorageInstanceSubDbInfoResponse, <-chan error) {
	responseChan := make(chan *DescribeStorageInstanceSubDbInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeStorageInstanceSubDbInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeStorageInstanceSubDbInfoWithCallback invokes the drds.DescribeStorageInstanceSubDbInfo API asynchronously
// api document: https://help.aliyun.com/api/drds/describestorageinstancesubdbinfo.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeStorageInstanceSubDbInfoWithCallback(request *DescribeStorageInstanceSubDbInfoRequest, callback func(response *DescribeStorageInstanceSubDbInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeStorageInstanceSubDbInfoResponse
		var err error
		defer close(result)
		response, err = client.DescribeStorageInstanceSubDbInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeStorageInstanceSubDbInfoRequest is the request struct for api DescribeStorageInstanceSubDbInfo
type DescribeStorageInstanceSubDbInfoRequest struct {
	*requests.RpcRequest
	InstanceId     string `position:"Query" name:"InstanceId"`
	DbName         string `position:"Query" name:"DbName"`
	DrdsInstanceId string `position:"Query" name:"DrdsInstanceId"`
	InstType       string `position:"Query" name:"InstType"`
}

// DescribeStorageInstanceSubDbInfoResponse is the response struct for api DescribeStorageInstanceSubDbInfo
type DescribeStorageInstanceSubDbInfoResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateDescribeStorageInstanceSubDbInfoRequest creates a request to invoke DescribeStorageInstanceSubDbInfo API
func CreateDescribeStorageInstanceSubDbInfoRequest() (request *DescribeStorageInstanceSubDbInfoRequest) {
	request = &DescribeStorageInstanceSubDbInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeStorageInstanceSubDbInfo", "drds", "openAPI")
	return
}

// CreateDescribeStorageInstanceSubDbInfoResponse creates a response to parse from DescribeStorageInstanceSubDbInfo response
func CreateDescribeStorageInstanceSubDbInfoResponse() (response *DescribeStorageInstanceSubDbInfoResponse) {
	response = &DescribeStorageInstanceSubDbInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
