package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetExpandLogicTableInfoList invokes the drds.GetExpandLogicTableInfoList API synchronously
// api document: https://help.aliyun.com/api/drds/getexpandlogictableinfolist.html
func (client *Client) GetExpandLogicTableInfoList(request *GetExpandLogicTableInfoListRequest) (response *GetExpandLogicTableInfoListResponse, err error) {
	response = CreateGetExpandLogicTableInfoListResponse()
	err = client.DoAction(request, response)
	return
}

// GetExpandLogicTableInfoListWithChan invokes the drds.GetExpandLogicTableInfoList API asynchronously
// api document: https://help.aliyun.com/api/drds/getexpandlogictableinfolist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetExpandLogicTableInfoListWithChan(request *GetExpandLogicTableInfoListRequest) (<-chan *GetExpandLogicTableInfoListResponse, <-chan error) {
	responseChan := make(chan *GetExpandLogicTableInfoListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetExpandLogicTableInfoList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetExpandLogicTableInfoListWithCallback invokes the drds.GetExpandLogicTableInfoList API asynchronously
// api document: https://help.aliyun.com/api/drds/getexpandlogictableinfolist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetExpandLogicTableInfoListWithCallback(request *GetExpandLogicTableInfoListRequest, callback func(response *GetExpandLogicTableInfoListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetExpandLogicTableInfoListResponse
		var err error
		defer close(result)
		response, err = client.GetExpandLogicTableInfoList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetExpandLogicTableInfoListRequest is the request struct for api GetExpandLogicTableInfoList
type GetExpandLogicTableInfoListRequest struct {
	*requests.RpcRequest
	DbName         string `position:"Query" name:"DbName"`
	DrdsInstanceId string `position:"Query" name:"DrdsInstanceId"`
}

// GetExpandLogicTableInfoListResponse is the response struct for api GetExpandLogicTableInfoList
type GetExpandLogicTableInfoListResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateGetExpandLogicTableInfoListRequest creates a request to invoke GetExpandLogicTableInfoList API
func CreateGetExpandLogicTableInfoListRequest() (request *GetExpandLogicTableInfoListRequest) {
	request = &GetExpandLogicTableInfoListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "GetExpandLogicTableInfoList", "drds", "openAPI")
	return
}

// CreateGetExpandLogicTableInfoListResponse creates a response to parse from GetExpandLogicTableInfoList response
func CreateGetExpandLogicTableInfoListResponse() (response *GetExpandLogicTableInfoListResponse) {
	response = &GetExpandLogicTableInfoListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
