package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// PreCheckCreateHiStoreInstance invokes the drds.PreCheckCreateHiStoreInstance API synchronously
// api document: https://help.aliyun.com/api/drds/precheckcreatehistoreinstance.html
func (client *Client) PreCheckCreateHiStoreInstance(request *PreCheckCreateHiStoreInstanceRequest) (response *PreCheckCreateHiStoreInstanceResponse, err error) {
	response = CreatePreCheckCreateHiStoreInstanceResponse()
	err = client.DoAction(request, response)
	return
}

// PreCheckCreateHiStoreInstanceWithChan invokes the drds.PreCheckCreateHiStoreInstance API asynchronously
// api document: https://help.aliyun.com/api/drds/precheckcreatehistoreinstance.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PreCheckCreateHiStoreInstanceWithChan(request *PreCheckCreateHiStoreInstanceRequest) (<-chan *PreCheckCreateHiStoreInstanceResponse, <-chan error) {
	responseChan := make(chan *PreCheckCreateHiStoreInstanceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.PreCheckCreateHiStoreInstance(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// PreCheckCreateHiStoreInstanceWithCallback invokes the drds.PreCheckCreateHiStoreInstance API asynchronously
// api document: https://help.aliyun.com/api/drds/precheckcreatehistoreinstance.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PreCheckCreateHiStoreInstanceWithCallback(request *PreCheckCreateHiStoreInstanceRequest, callback func(response *PreCheckCreateHiStoreInstanceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *PreCheckCreateHiStoreInstanceResponse
		var err error
		defer close(result)
		response, err = client.PreCheckCreateHiStoreInstance(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// PreCheckCreateHiStoreInstanceRequest is the request struct for api PreCheckCreateHiStoreInstance
type PreCheckCreateHiStoreInstanceRequest struct {
	*requests.RpcRequest
	DrdsPassword   string `position:"Query" name:"DrdsPassword"`
	DrdsInstanceId string `position:"Query" name:"DrdsInstanceId"`
}

// PreCheckCreateHiStoreInstanceResponse is the response struct for api PreCheckCreateHiStoreInstance
type PreCheckCreateHiStoreInstanceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      int64  `json:"Data" xml:"Data"`
}

// CreatePreCheckCreateHiStoreInstanceRequest creates a request to invoke PreCheckCreateHiStoreInstance API
func CreatePreCheckCreateHiStoreInstanceRequest() (request *PreCheckCreateHiStoreInstanceRequest) {
	request = &PreCheckCreateHiStoreInstanceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "PreCheckCreateHiStoreInstance", "drds", "openAPI")
	return
}

// CreatePreCheckCreateHiStoreInstanceResponse creates a response to parse from PreCheckCreateHiStoreInstance response
func CreatePreCheckCreateHiStoreInstanceResponse() (response *PreCheckCreateHiStoreInstanceResponse) {
	response = &PreCheckCreateHiStoreInstanceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
