package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// PutRestorePreCheck invokes the drds.PutRestorePreCheck API synchronously
// api document: https://help.aliyun.com/api/drds/putrestoreprecheck.html
func (client *Client) PutRestorePreCheck(request *PutRestorePreCheckRequest) (response *PutRestorePreCheckResponse, err error) {
	response = CreatePutRestorePreCheckResponse()
	err = client.DoAction(request, response)
	return
}

// PutRestorePreCheckWithChan invokes the drds.PutRestorePreCheck API asynchronously
// api document: https://help.aliyun.com/api/drds/putrestoreprecheck.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PutRestorePreCheckWithChan(request *PutRestorePreCheckRequest) (<-chan *PutRestorePreCheckResponse, <-chan error) {
	responseChan := make(chan *PutRestorePreCheckResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.PutRestorePreCheck(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// PutRestorePreCheckWithCallback invokes the drds.PutRestorePreCheck API asynchronously
// api document: https://help.aliyun.com/api/drds/putrestoreprecheck.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PutRestorePreCheckWithCallback(request *PutRestorePreCheckRequest, callback func(response *PutRestorePreCheckResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *PutRestorePreCheckResponse
		var err error
		defer close(result)
		response, err = client.PutRestorePreCheck(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// PutRestorePreCheckRequest is the request struct for api PutRestorePreCheck
type PutRestorePreCheckRequest struct {
	*requests.RpcRequest
	PreferredBackupTime string `position:"Query" name:"PreferredBackupTime"`
	BackupDbNames       string `position:"Query" name:"BackupDbNames"`
	BackupId            string `position:"Query" name:"BackupId"`
	BackupMode          string `position:"Query" name:"BackupMode"`
	BackupLevel         string `position:"Query" name:"BackupLevel"`
	DrdsInstanceId      string `position:"Query" name:"DrdsInstanceId"`
}

// PutRestorePreCheckResponse is the response struct for api PutRestorePreCheck
type PutRestorePreCheckResponse struct {
	*responses.BaseResponse
	RequestId            string               `json:"RequestId" xml:"RequestId"`
	Success              bool                 `json:"Success" xml:"Success"`
	PrecheckBackupResult PrecheckBackupResult `json:"PrecheckBackupResult" xml:"PrecheckBackupResult"`
}

// CreatePutRestorePreCheckRequest creates a request to invoke PutRestorePreCheck API
func CreatePutRestorePreCheckRequest() (request *PutRestorePreCheckRequest) {
	request = &PutRestorePreCheckRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "PutRestorePreCheck", "drds", "openAPI")
	return
}

// CreatePutRestorePreCheckResponse creates a response to parse from PutRestorePreCheck response
func CreatePutRestorePreCheckResponse() (response *PutRestorePreCheckResponse) {
	response = &PutRestorePreCheckResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
