package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RearrangeDbToInstance invokes the drds.RearrangeDbToInstance API synchronously
// api document: https://help.aliyun.com/api/drds/rearrangedbtoinstance.html
func (client *Client) RearrangeDbToInstance(request *RearrangeDbToInstanceRequest) (response *RearrangeDbToInstanceResponse, err error) {
	response = CreateRearrangeDbToInstanceResponse()
	err = client.DoAction(request, response)
	return
}

// RearrangeDbToInstanceWithChan invokes the drds.RearrangeDbToInstance API asynchronously
// api document: https://help.aliyun.com/api/drds/rearrangedbtoinstance.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RearrangeDbToInstanceWithChan(request *RearrangeDbToInstanceRequest) (<-chan *RearrangeDbToInstanceResponse, <-chan error) {
	responseChan := make(chan *RearrangeDbToInstanceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RearrangeDbToInstance(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RearrangeDbToInstanceWithCallback invokes the drds.RearrangeDbToInstance API asynchronously
// api document: https://help.aliyun.com/api/drds/rearrangedbtoinstance.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) RearrangeDbToInstanceWithCallback(request *RearrangeDbToInstanceRequest, callback func(response *RearrangeDbToInstanceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RearrangeDbToInstanceResponse
		var err error
		defer close(result)
		response, err = client.RearrangeDbToInstance(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RearrangeDbToInstanceRequest is the request struct for api RearrangeDbToInstance
type RearrangeDbToInstanceRequest struct {
	*requests.RpcRequest
	ChooseSubDb    string    `position:"Query" name:"ChooseSubDb"`
	InstanceList   *[]string `position:"Query" name:"InstanceList"  type:"Repeated"`
	DbName         string    `position:"Query" name:"DbName"`
	OrderId        string    `position:"Query" name:"OrderId"`
	ChooseRds      string    `position:"Query" name:"ChooseRds"`
	DrdsInstanceId string    `position:"Query" name:"DrdsInstanceId"`
}

// RearrangeDbToInstanceResponse is the response struct for api RearrangeDbToInstance
type RearrangeDbToInstanceResponse struct {
	*responses.BaseResponse
	RequestId string                      `json:"RequestId" xml:"RequestId"`
	Success   bool                        `json:"Success" xml:"Success"`
	Data      DataInRearrangeDbToInstance `json:"Data" xml:"Data"`
}

// CreateRearrangeDbToInstanceRequest creates a request to invoke RearrangeDbToInstance API
func CreateRearrangeDbToInstanceRequest() (request *RearrangeDbToInstanceRequest) {
	request = &RearrangeDbToInstanceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "RearrangeDbToInstance", "drds", "openAPI")
	return
}

// CreateRearrangeDbToInstanceResponse creates a response to parse from RearrangeDbToInstance response
func CreateRearrangeDbToInstanceResponse() (response *RearrangeDbToInstanceResponse) {
	response = &RearrangeDbToInstanceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
