package dysmsapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QuerySmsProdStatus invokes the dysmsapi.QuerySmsProdStatus API synchronously
// api document: https://help.aliyun.com/api/dysmsapi/querysmsprodstatus.html
func (client *Client) QuerySmsProdStatus(request *QuerySmsProdStatusRequest) (response *QuerySmsProdStatusResponse, err error) {
	response = CreateQuerySmsProdStatusResponse()
	err = client.DoAction(request, response)
	return
}

// QuerySmsProdStatusWithChan invokes the dysmsapi.QuerySmsProdStatus API asynchronously
// api document: https://help.aliyun.com/api/dysmsapi/querysmsprodstatus.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QuerySmsProdStatusWithChan(request *QuerySmsProdStatusRequest) (<-chan *QuerySmsProdStatusResponse, <-chan error) {
	responseChan := make(chan *QuerySmsProdStatusResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QuerySmsProdStatus(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QuerySmsProdStatusWithCallback invokes the dysmsapi.QuerySmsProdStatus API asynchronously
// api document: https://help.aliyun.com/api/dysmsapi/querysmsprodstatus.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QuerySmsProdStatusWithCallback(request *QuerySmsProdStatusRequest, callback func(response *QuerySmsProdStatusResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QuerySmsProdStatusResponse
		var err error
		defer close(result)
		response, err = client.QuerySmsProdStatus(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QuerySmsProdStatusRequest is the request struct for api QuerySmsProdStatus
type QuerySmsProdStatusRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	AliyUid              requests.Integer `position:"Query" name:"AliyUid"`
}

// QuerySmsProdStatusResponse is the response struct for api QuerySmsProdStatus
type QuerySmsProdStatusResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Code      string `json:"Code" xml:"Code"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateQuerySmsProdStatusRequest creates a request to invoke QuerySmsProdStatus API
func CreateQuerySmsProdStatusRequest() (request *QuerySmsProdStatusRequest) {
	request = &QuerySmsProdStatusRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dysmsapi", "2017-05-25", "QuerySmsProdStatus", "dysms", "openAPI")
	return
}

// CreateQuerySmsProdStatusResponse creates a response to parse from QuerySmsProdStatus response
func CreateQuerySmsProdStatusResponse() (response *QuerySmsProdStatusResponse) {
	response = &QuerySmsProdStatusResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
