package elasticsearch

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ConvertLogstashPayType invokes the elasticsearch.ConvertLogstashPayType API synchronously
// api document: https://help.aliyun.com/api/elasticsearch/convertlogstashpaytype.html
func (client *Client) ConvertLogstashPayType(request *ConvertLogstashPayTypeRequest) (response *ConvertLogstashPayTypeResponse, err error) {
	response = CreateConvertLogstashPayTypeResponse()
	err = client.DoAction(request, response)
	return
}

// ConvertLogstashPayTypeWithChan invokes the elasticsearch.ConvertLogstashPayType API asynchronously
// api document: https://help.aliyun.com/api/elasticsearch/convertlogstashpaytype.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ConvertLogstashPayTypeWithChan(request *ConvertLogstashPayTypeRequest) (<-chan *ConvertLogstashPayTypeResponse, <-chan error) {
	responseChan := make(chan *ConvertLogstashPayTypeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ConvertLogstashPayType(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ConvertLogstashPayTypeWithCallback invokes the elasticsearch.ConvertLogstashPayType API asynchronously
// api document: https://help.aliyun.com/api/elasticsearch/convertlogstashpaytype.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ConvertLogstashPayTypeWithCallback(request *ConvertLogstashPayTypeRequest, callback func(response *ConvertLogstashPayTypeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ConvertLogstashPayTypeResponse
		var err error
		defer close(result)
		response, err = client.ConvertLogstashPayType(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ConvertLogstashPayTypeRequest is the request struct for api ConvertLogstashPayType
type ConvertLogstashPayTypeRequest struct {
	*requests.RoaRequest
	InstanceId  string `position:"Path" name:"InstanceId"`
	ClientToken string `position:"Query" name:"clientToken"`
}

// ConvertLogstashPayTypeResponse is the response struct for api ConvertLogstashPayType
type ConvertLogstashPayTypeResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Result    bool   `json:"Result" xml:"Result"`
}

// CreateConvertLogstashPayTypeRequest creates a request to invoke ConvertLogstashPayType API
func CreateConvertLogstashPayTypeRequest() (request *ConvertLogstashPayTypeRequest) {
	request = &ConvertLogstashPayTypeRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("elasticsearch", "2017-06-13", "ConvertLogstashPayType", "/openapi/logstashes/[InstanceId]/convert-pay-type", "elasticsearch", "openAPI")
	request.Method = requests.POST
	return
}

// CreateConvertLogstashPayTypeResponse creates a response to parse from ConvertLogstashPayType response
func CreateConvertLogstashPayTypeResponse() (response *ConvertLogstashPayTypeResponse) {
	response = &ConvertLogstashPayTypeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
