package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyClusterHostGroup invokes the emr.ModifyClusterHostGroup API synchronously
// api document: https://help.aliyun.com/api/emr/modifyclusterhostgroup.html
func (client *Client) ModifyClusterHostGroup(request *ModifyClusterHostGroupRequest) (response *ModifyClusterHostGroupResponse, err error) {
	response = CreateModifyClusterHostGroupResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyClusterHostGroupWithChan invokes the emr.ModifyClusterHostGroup API asynchronously
// api document: https://help.aliyun.com/api/emr/modifyclusterhostgroup.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyClusterHostGroupWithChan(request *ModifyClusterHostGroupRequest) (<-chan *ModifyClusterHostGroupResponse, <-chan error) {
	responseChan := make(chan *ModifyClusterHostGroupResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyClusterHostGroup(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyClusterHostGroupWithCallback invokes the emr.ModifyClusterHostGroup API asynchronously
// api document: https://help.aliyun.com/api/emr/modifyclusterhostgroup.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyClusterHostGroupWithCallback(request *ModifyClusterHostGroupRequest, callback func(response *ModifyClusterHostGroupResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyClusterHostGroupResponse
		var err error
		defer close(result)
		response, err = client.ModifyClusterHostGroup(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyClusterHostGroupRequest is the request struct for api ModifyClusterHostGroup
type ModifyClusterHostGroupRequest struct {
	*requests.RpcRequest
	VswitchId       string           `position:"Query" name:"VswitchId"`
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	HostGroupId     string           `position:"Query" name:"HostGroupId"`
	SecurityGroupId string           `position:"Query" name:"SecurityGroupId"`
	Comment         string           `position:"Query" name:"Comment"`
	ClusterId       string           `position:"Query" name:"ClusterId"`
	HostGroupName   string           `position:"Query" name:"HostGroupName"`
}

// ModifyClusterHostGroupResponse is the response struct for api ModifyClusterHostGroup
type ModifyClusterHostGroupResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyClusterHostGroupRequest creates a request to invoke ModifyClusterHostGroup API
func CreateModifyClusterHostGroupRequest() (request *ModifyClusterHostGroupRequest) {
	request = &ModifyClusterHostGroupRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "ModifyClusterHostGroup", "emr", "openAPI")
	return
}

// CreateModifyClusterHostGroupResponse creates a response to parse from ModifyClusterHostGroup response
func CreateModifyClusterHostGroupResponse() (response *ModifyClusterHostGroupResponse) {
	response = &ModifyClusterHostGroupResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
