package green

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateWebsiteInstance invokes the green.UpdateWebsiteInstance API synchronously
// api document: https://help.aliyun.com/api/green/updatewebsiteinstance.html
func (client *Client) UpdateWebsiteInstance(request *UpdateWebsiteInstanceRequest) (response *UpdateWebsiteInstanceResponse, err error) {
	response = CreateUpdateWebsiteInstanceResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateWebsiteInstanceWithChan invokes the green.UpdateWebsiteInstance API asynchronously
// api document: https://help.aliyun.com/api/green/updatewebsiteinstance.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) UpdateWebsiteInstanceWithChan(request *UpdateWebsiteInstanceRequest) (<-chan *UpdateWebsiteInstanceResponse, <-chan error) {
	responseChan := make(chan *UpdateWebsiteInstanceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateWebsiteInstance(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateWebsiteInstanceWithCallback invokes the green.UpdateWebsiteInstance API asynchronously
// api document: https://help.aliyun.com/api/green/updatewebsiteinstance.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) UpdateWebsiteInstanceWithCallback(request *UpdateWebsiteInstanceRequest, callback func(response *UpdateWebsiteInstanceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateWebsiteInstanceResponse
		var err error
		defer close(result)
		response, err = client.UpdateWebsiteInstance(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateWebsiteInstanceRequest is the request struct for api UpdateWebsiteInstance
type UpdateWebsiteInstanceRequest struct {
	*requests.RpcRequest
	IndexPage             string           `position:"Query" name:"IndexPage"`
	SourceIp              string           `position:"Query" name:"SourceIp"`
	Lang                  string           `position:"Query" name:"Lang"`
	WebsiteScanInterval   requests.Integer `position:"Query" name:"WebsiteScanInterval"`
	SiteProtocol          string           `position:"Query" name:"SiteProtocol"`
	InstanceId            string           `position:"Query" name:"InstanceId"`
	Domain                string           `position:"Query" name:"Domain"`
	IndexPageScanInterval requests.Integer `position:"Query" name:"IndexPageScanInterval"`
}

// UpdateWebsiteInstanceResponse is the response struct for api UpdateWebsiteInstance
type UpdateWebsiteInstanceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateUpdateWebsiteInstanceRequest creates a request to invoke UpdateWebsiteInstance API
func CreateUpdateWebsiteInstanceRequest() (request *UpdateWebsiteInstanceRequest) {
	request = &UpdateWebsiteInstanceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Green", "2017-08-23", "UpdateWebsiteInstance", "green", "openAPI")
	return
}

// CreateUpdateWebsiteInstanceResponse creates a response to parse from UpdateWebsiteInstance response
func CreateUpdateWebsiteInstanceResponse() (response *UpdateWebsiteInstanceResponse) {
	response = &UpdateWebsiteInstanceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
