package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// PreCheckCreateOrderForDefer invokes the rds.PreCheckCreateOrderForDefer API synchronously
// api document: https://help.aliyun.com/api/rds/precheckcreateorderfordefer.html
func (client *Client) PreCheckCreateOrderForDefer(request *PreCheckCreateOrderForDeferRequest) (response *PreCheckCreateOrderForDeferResponse, err error) {
	response = CreatePreCheckCreateOrderForDeferResponse()
	err = client.DoAction(request, response)
	return
}

// PreCheckCreateOrderForDeferWithChan invokes the rds.PreCheckCreateOrderForDefer API asynchronously
// api document: https://help.aliyun.com/api/rds/precheckcreateorderfordefer.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PreCheckCreateOrderForDeferWithChan(request *PreCheckCreateOrderForDeferRequest) (<-chan *PreCheckCreateOrderForDeferResponse, <-chan error) {
	responseChan := make(chan *PreCheckCreateOrderForDeferResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.PreCheckCreateOrderForDefer(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// PreCheckCreateOrderForDeferWithCallback invokes the rds.PreCheckCreateOrderForDefer API asynchronously
// api document: https://help.aliyun.com/api/rds/precheckcreateorderfordefer.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PreCheckCreateOrderForDeferWithCallback(request *PreCheckCreateOrderForDeferRequest, callback func(response *PreCheckCreateOrderForDeferResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *PreCheckCreateOrderForDeferResponse
		var err error
		defer close(result)
		response, err = client.PreCheckCreateOrderForDefer(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// PreCheckCreateOrderForDeferRequest is the request struct for api PreCheckCreateOrderForDefer
type PreCheckCreateOrderForDeferRequest struct {
	*requests.RpcRequest
	ResourceOwnerId       requests.Integer `position:"Query" name:"ResourceOwnerId"`
	DBInstanceStorage     requests.Integer `position:"Query" name:"DBInstanceStorage"`
	ClientToken           string           `position:"Query" name:"ClientToken"`
	RenewChange           requests.Boolean `position:"Query" name:"RenewChange"`
	DBInstanceId          string           `position:"Query" name:"DBInstanceId"`
	DBInstanceStorageType string           `position:"Query" name:"DBInstanceStorageType"`
	BusinessInfo          string           `position:"Query" name:"BusinessInfo"`
	AutoPay               requests.Boolean `position:"Query" name:"AutoPay"`
	ResourceOwnerAccount  string           `position:"Query" name:"ResourceOwnerAccount"`
	Resource              string           `position:"Query" name:"Resource"`
	CommodityCode         string           `position:"Query" name:"CommodityCode"`
	OwnerId               requests.Integer `position:"Query" name:"OwnerId"`
	UsedTime              string           `position:"Query" name:"UsedTime"`
	DBInstanceClass       string           `position:"Query" name:"DBInstanceClass"`
	TimeType              string           `position:"Query" name:"TimeType"`
	PayType               string           `position:"Query" name:"PayType"`
}

// PreCheckCreateOrderForDeferResponse is the response struct for api PreCheckCreateOrderForDefer
type PreCheckCreateOrderForDeferResponse struct {
	*responses.BaseResponse
	RequestId      string                                `json:"RequestId" xml:"RequestId"`
	PreCheckResult bool                                  `json:"PreCheckResult" xml:"PreCheckResult"`
	Failures       FailuresInPreCheckCreateOrderForDefer `json:"Failures" xml:"Failures"`
}

// CreatePreCheckCreateOrderForDeferRequest creates a request to invoke PreCheckCreateOrderForDefer API
func CreatePreCheckCreateOrderForDeferRequest() (request *PreCheckCreateOrderForDeferRequest) {
	request = &PreCheckCreateOrderForDeferRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "PreCheckCreateOrderForDefer", "rds", "openAPI")
	return
}

// CreatePreCheckCreateOrderForDeferResponse creates a response to parse from PreCheckCreateOrderForDefer response
func CreatePreCheckCreateOrderForDeferResponse() (response *PreCheckCreateOrderForDeferResponse) {
	response = &PreCheckCreateOrderForDeferResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
