package rds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// PreCheckDBInstanceOperation invokes the rds.PreCheckDBInstanceOperation API synchronously
// api document: https://help.aliyun.com/api/rds/precheckdbinstanceoperation.html
func (client *Client) PreCheckDBInstanceOperation(request *PreCheckDBInstanceOperationRequest) (response *PreCheckDBInstanceOperationResponse, err error) {
	response = CreatePreCheckDBInstanceOperationResponse()
	err = client.DoAction(request, response)
	return
}

// PreCheckDBInstanceOperationWithChan invokes the rds.PreCheckDBInstanceOperation API asynchronously
// api document: https://help.aliyun.com/api/rds/precheckdbinstanceoperation.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PreCheckDBInstanceOperationWithChan(request *PreCheckDBInstanceOperationRequest) (<-chan *PreCheckDBInstanceOperationResponse, <-chan error) {
	responseChan := make(chan *PreCheckDBInstanceOperationResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.PreCheckDBInstanceOperation(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// PreCheckDBInstanceOperationWithCallback invokes the rds.PreCheckDBInstanceOperation API asynchronously
// api document: https://help.aliyun.com/api/rds/precheckdbinstanceoperation.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PreCheckDBInstanceOperationWithCallback(request *PreCheckDBInstanceOperationRequest, callback func(response *PreCheckDBInstanceOperationResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *PreCheckDBInstanceOperationResponse
		var err error
		defer close(result)
		response, err = client.PreCheckDBInstanceOperation(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// PreCheckDBInstanceOperationRequest is the request struct for api PreCheckDBInstanceOperation
type PreCheckDBInstanceOperationRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	DBInstanceId         string           `position:"Query" name:"DBInstanceId"`
	Operation            string           `position:"Query" name:"Operation"`
}

// PreCheckDBInstanceOperationResponse is the response struct for api PreCheckDBInstanceOperation
type PreCheckDBInstanceOperationResponse struct {
	*responses.BaseResponse
	RequestId      string                                `json:"RequestId" xml:"RequestId"`
	PreCheckResult bool                                  `json:"PreCheckResult" xml:"PreCheckResult"`
	Failures       FailuresInPreCheckDBInstanceOperation `json:"Failures" xml:"Failures"`
}

// CreatePreCheckDBInstanceOperationRequest creates a request to invoke PreCheckDBInstanceOperation API
func CreatePreCheckDBInstanceOperationRequest() (request *PreCheckDBInstanceOperationRequest) {
	request = &PreCheckDBInstanceOperationRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rds", "2014-08-15", "PreCheckDBInstanceOperation", "rds", "openAPI")
	return
}

// CreatePreCheckDBInstanceOperationResponse creates a response to parse from PreCheckDBInstanceOperation response
func CreatePreCheckDBInstanceOperationResponse() (response *PreCheckDBInstanceOperationResponse) {
	response = &PreCheckDBInstanceOperationResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
